/*
 * $Source: /mnt/cvs/rep/CW/CFQE20/Sources/main.c,v $
 * $Id: main.c,v 1.5 2008/02/18 14:09:24 noritan Exp $
 */
#include <hidef.h> /* for EnableInterrupts macro */
#include "derivative.h" /* include peripheral declarations */

// 萔̐錾
#define   BUF_LENGTH  (72)
#define   TEXT_LENGTH (4096)

// ϐoN
dword   varBank[32];        // ʏϐ
word    lineNumber;         // column index.

// ϐ̐錾
char lineBuf[BUF_LENGTH];   // Cobt@
char *linePoint;            // C|C^
char *columnPoint;          // J|C^
char *lhsPoint;             // ӎ|C^
char textBuf[TEXT_LENGTH];  // eLXg̈
char *textEnd;              // eLXgI[|C^


// ֗֐̐錾
int     getc(void);
void    putc(int ch);
void    puts(const char *s);
char    *getLine(void);
int     getNumber(void);
void    insertLine(int lineno, char *line);
void    removeLineByNo(int lineno);
char    *findLine(int lineno);
void    listLines(void);
void    putNumber(int lineno);
char    *nextLine(char *line);
byte    isDelimit(const char ch);


// void executeStatement(void)
//   ̎s
void executeStatement(void) {
  char ch;
  
  while ((ch = *columnPoint) != 0) {
    if (ch == ' ') {
      // ̋؂
      columnPoint++;
      continue;
    }
    // ϐ
    lineNumber = 0;
    if (isDelimit(*(columnPoint+1))) {
      // ꕶR}h
      // No commands implemented.
    }
    if (ch =='"') {
      // \
      columnPoint++;
      for (;;) {
        ch = *columnPoint++;
        if ((ch == 0) || (ch == '"')) {
          break;
        }
        putc(ch);
      }
    } else if (ch == '/') {
      // s\
      while (ch == '/') {
        putc('\n');
        ch = *(++columnPoint);
      }
    } else {
      lhsPoint = columnPoint;
      columnPoint++;
    }
  }
}


// void executeDirect(void)
//   Cobt@R}h̎s
void executeDirect(void) {
  executeStatement();               // Cobt@̎s
  lineNumber = 1;                   // G~[V
  while (lineNumber != 0) {         // 򂵂A
    linePoint = findLine(lineNumber); // T
    for (;;) {
      if (linePoint >= textEnd) {   // vOI[ɓB
        return;                     // GfB^ɖ߂
      }
      columnPoint = linePoint + 2;  // sԍ΂
      if (*columnPoint != ' ') {
        // RgsXLbv
        linePoint = nextLine(linePoint);
      } else {
        executeStatement();         // ss
        if (lineNumber != 0) {      // sԍύXꂽ
          break;                    // 
        }
        // ̍sɐi
        linePoint = nextLine(linePoint);
      }
    }
  }
}


// void main(void)
//   C֐
void main(void) {
  int       nLine;        // ͂l
  
  // SOPT1ݒ肷
  // COP͒~
  SOPT1 = 0
    | SOPT1_WAITE_MASK    // WAIT߂
    | SOPT1_RSTOPE_MASK   // RSTO*o͂g
    | SOPT1_BKGDPE_MASK   // BKGD|[gg
    | SOPT1_RSTPE_MASK ;  // RESET*͂g

  // ICSݒ肷
  //   REFCLK = 31,250Hz
  //   DCO    = 48,000,000Hz
  //   BUSCLK = DCO / 2 = 24,000,000Hz
  ICSTRM          = NVICSTRM;
  ICSSC_FTRIM     = NVFTRIM_FTRIM;
  ICSC2_BDIV      = 0;  // BDIV 1/1
  ICSSC_DRST_DRS  = 2;  // FLL x1536
  
  // SCI1ݒ肷
  //   BAUD   = 115200
  //   BR     = BUSCLK / BAUD / 16 = 13
  SCI1BD_SBR = 13;      // NbN
  SCI1C2_TE  = 1;       // M@\Lɂ
  SCI1C2_RE  = 1;       // M@\Lɂ
  
  // eLXgGȀ
  textBuf[0] = -1;
  textEnd = &textBuf[0];

  EnableInterrupts; /* enable interrupts */
  /* include your code here */

  for (;;) {
    puts("\n*READY\n");         // vvg\
    for (;;) {
      linePoint = getLine();    // sM
      columnPoint = linePoint;  // J|C^̐ݒ
      nLine = getNumber();      // lo
      if (nLine < 0) {          // lȂɂ
        executeDirect();        // ̎s
        break;                  // vvg̕\
      } else if (nLine == 0) {  // l0̎ɂ́A
        listLines();            // Xg\
        break;                  // vvg̕\
      } else if (!*columnPoint) { // l̎ɂ́A
        removeLineByNo(nLine);  // 폜
      } else {                  // ȊÓA
        insertLine(nLine, columnPoint); // }
      } 
    }
  } /* loop forever */
  /* please make sure that you never leave main */
}


// char *getLine(void) : 
//   sM[`
//   Cobt@̐擪Ԃ
char *getLine(void) {
  char  *p;             // obt@|C^
  char  c;              // ꕶobt@
  
  for (;;) {
    putc(':');          // vvgo
    p = lineBuf;        // obt@̐擪w
    for (;;) {
      c = (char)getc(); // ꕶ󂯎
      if (c == 8) {
        // Back Spacȅ
        putc(c);        // J[\ǂ
        p--;            // ꕶ߂
        // |C^obt@̐擪ɒBA
        // vvgo͂ȂB
        if (p < lineBuf) break;
      } else if (c == '\n') {
        // Enteȑ
        putc(c);        // so
        *p = 0;         // 񖖕
        return lineBuf; // obt@ւ̃|C^Ԃ
      } else if (c < ' ') {
        // ̑̃Rg[
        continue;       // Pɖ
      } else if (c == 127) {
        // DELETȄ
        putc('\n');     // so
        break;          // vvgo͂Ȃ
      } else {
        // ʏ̏̕
        putc(c);        // GR[obN
        *p++ = c;       // obt@ɏ
        // obt@g؂A
        if (p >= &lineBuf[BUF_LENGTH-1]) {
          putc('\n');   // so
          break;        // vvgo͂Ȃ
        }
      }
    }
  }
}

// int getc(void) : 
//   ꕶM[`
int getc(void) {
  int ch;               // obt@
  
  // Mobt@ςɂȂ̂҂
  while (!SCI1S1_RDRF) {
    // Do nothing
  }
  ch = SCI1D;           // ꕶ󂯎
  if (ch == '\r') {     // EnterL[́A
    ch = '\n';          // sɕϊ
  }
  return ch;            // 󂯎Ԃ
}


// void putc(int ch) : 
//   ꕶM[`
void putc(int ch) {
  if (ch == '\n') {     // s̑OCRt
    // Mobt@󂭂̂҂
    while (!SCI1S1_TDRE) {
      // Do nothing
    }
    SCI1D = '\r';       // SCICR𑗐M
  }
  // Mobt@󂭂̂҂
  while (!SCI1S1_TDRE) {
    // Do nothing
  }
  SCI1D = (byte)ch;     // SCIɈꕶM
}


// void puts(const char *s) : 
//   񑗐M[`
void puts(const char *s) {
  while (*s) {          // 񖖂łȂ΁A
    putc(*s++);         // ꕶM
  }
}


// byte isDelimit(const char ch)
//   f~b^o
byte isDelimit(const char ch) {
  return (ch == 0) || (ch == ' ');
}

// int getNumber(void) : 
//   J|C^̈ʒu琔lo
int getNumber(void) {
  int n = 0;                    // l
  
  if (!isdigit(*columnPoint)) { // Ȃ΁A 
    return -1;                  // -1 Ԃ
  }
  while (isdigit(*columnPoint)) { // l̏\iϊ
    n = n * 10 + ((*columnPoint) - '0');
    columnPoint++;
  }
  return n;                     // lԂ
}


// void putNumber(int n) : 
//   l̕\ - ZERO SUPPRESS ͏ȗB
void putNumber(int n) {
  int m = 10000;          // ڂ錅
  
  while (m > 0) {           // ̈ʂ܂ŕ\
    putc((n / m) + '0');    // ڌ̕\
    n %= m;                 // č̕
    m /= 10;                // ڌ̈ړ
  }
}

// int getLineNo(line)
//   sԍo
int getLineNo(char *line) {
   return *((word *)line);
}


// char *nextLine(line)
//   ̍sɃXLbv
char *nextLine(char *line) {
  char *s;
  for (s = line + 2; *s++; ) {
  }
  return s;
}


// void removeLine(line)
//   |C^Ŏws폜B
void removeLine(char *line) {
  const char *s;
  char *p;
  
  // 폜
  p = (char *)line;
  s = nextLine(line);
  while (s < textEnd) {
    *p++ = *s++;
  }
  *p = *s;
  textEnd = p;
}


// char *findLine(lineno)
//   s
char *findLine(int lineno) {
  char *s;

  // sT
  s = textBuf;
  for (;;) {
    // eLXg[ɓB    
    if (s >= textEnd) {
      break;
    }
    // sԍ؁B
    if (getLineNo(s) >= lineno) {
      // sʒu
      break;
    }
    // ̍sɃXLbv
    s = nextLine(s);
  }
  return s;
}


// void insertLine(lineno, line) : 
//   s}
void insertLine(int lineno, char *line) {
  char *s;
  char *p;
  char *pInsert;
  int length;
  
  // }ʒuT
  pInsert = findLine(lineno);
  // sԍ؁B
  if (getLineNo(pInsert) == lineno) {
    // u
    // u̕vZB
    length = strlen(line) - strlen(&pInsert[2]);
    if (length > 0) {
      // ꏊgđ}
      if (textEnd - textBuf + length > TEXT_LENGTH) {
        // obt@EI[ot[
        pInsert = 0;
      } else {
        // g
        p = textEnd + length;
        s = textEnd;
        while (s >= pInsert) {
          *p-- = *s--;
        }
        textEnd += length;
      }
    } else if (length < 0) {
      // ꏊkđ}
      s = nextLine(pInsert);
      p = s + length;
      while (s <= textEnd) {
        *p++ = *s++;
      }
      textEnd += length;
    } else {
      // ㏑
    }
  } else {
    // obt@E`FbN
    length = strlen(line) + 3;
    if (textEnd - textBuf + length > TEXT_LENGTH) {
      // obt@EI[ot[
      pInsert = 0;
    } else {      
      // ۂƊgđ}
      p = textEnd + length;
      s = textEnd;
      while (s >= pInsert) {
        *p-- = *s--;
      }
      textEnd += length;
    }
  }
  
  // }ʒuȂ΁AȂB
  if (!pInsert) {
    return;
  }

  // }Jn
  p = pInsert;
  // sԍ
  *((word *)p) = (word)lineno;
  p += 2;
  // {̂
  for (s = line; *s; ) {
    *p++ = *s++;
  }
  // s
  *p++ = 0;
}


// void removeLineByNo(lineno)
//   ^ꂽsԍ̍s폜
void removeLineByNo(int lineno) {
  char *s;
  
  // 폜ʒuT
  s = findLine(lineno);
  // sԍr
  if (getLineNo(s) == lineno) {
    removeLine(s);
  }
}


// void listLines(void)
//   Xgo
void listLines(void) {
  char *p;
  
  // eLXgI[܂ŕ\B
  for (p = textBuf; p < textEnd; ) {
    // sԍ\
    putNumber(getLineNo(p));
    p += 2;
    // {\
    while (*p) {
      putc(*p++);
    }
    putc('\n');
    // sXLbv
    p++;
  }
}
